/*Funcin: FVARSCB.CPP
	Proceso: Contiene todas las constantes,estructuras,variables,
					 punteros y declaracin de funciones que usa el programa SCB.CPP*/

#include "io.h"
#include "time.h"
#include "dir.h"
#include "dos.h"
#include "conio.h"
#include "ctype.h"
#include "string.h"
#include "bios.h"
#include "stdio.h"
#include "stdlib.h"
#include "graphics.h"
#include "alloc.h"
#include "process.h"

#define NRP   8              //Nm. de registros +1 que se ven por pantalla
#define SP    25             //Espacio de muestreo entre un registro y otro
#define PL    2              //Pantallas por leer y cargar en arreglo;carga total PL+1
#define MAXR  (NRP+1)*(PL+1) //Mx. nm. de registros que se cargan en arreglos
#define CF    0              //Color del fondo de la pantalla
#define MALT  5 				     //Mx. nm. de altas antes de guardar,antes (NRP+1)*np (np=nm. de pantallas)
#define MT    9              //Mx. de materias por libro
#define MP    6              //Mx. titulos por prstamo
#define LR    57             //Logitud de ruta,incluyendo nombre del arch.
#define AC    16             //Nm. mx. de caracteres para contrasea
#define LA    23             //Nm. mx. de lneas de ayuda a visualizar
#define LTA   40             //Nm. mx. de lneas de ayuda que se cargan en arreglo
#define NTIPH 18             //Nm de ttulos impresos por hoja en inventario

//NOTA: +1 a cada campo,por haber ligamiento al ocupar su mximo tamao
struct campstructs    //Campos estructuras
 {                    //Carpeta o tipo de material:0=LIBROS,1=REVISTAS,2=PERIODICOS,3=FOLLETOS,4=FASCICULOS,5=VARIOS,6=USUARIOS
	char titul[41];
	char autor[36];
	char campo3[21];    //Editorial o Fecha(dd/mm/aaaa)
	char temas[MT][41]; //Slo libro
	char consul;        //Area de consulta 'C' (slo consulta interna) o ' '
	char clasif[31];
	char volume[4];     //Volumen o Fascculo
	char edicio[20];
	char anio[5];       //Slo revista
	char num[4];        //Slo revista
	int existencia,prestados,numresrva;
	char prestamo;      //I:interno,E:externo
 }ejemplar;           //Utilizado en Prestamo para traer los datos del ttulo selecionado

struct adqdat
 {
	long posicion;    //Ubicacin en el catlogo
	int numejemp;     //Nm. consecutivo de los ejemplares del mismo ttulo
	char numadqui[7]; //Nm. consecutivo dado por el total del tipo de material en el catlogo
	char numenvio[9]; //Eje: 58/2000C = 58:consec/2000:ao,C  D:compra o donacin
	char fent[11],fsal[11]; //Fecha de entrada y salida
	char prestado;    //' '=No prestado,'P'=Prestado,'E'=extraviado
 }adqui;

struct index
 {
	long posicion;    //Ubicacin en arch. maestro
	char atet[41];    //Para cualquiera de los campos indexados
 }vindex[MAXR],ndx; //Contiene parte y control del indice primario

struct usuario
 {
	char numcred[11];      //Nm. de credencial de biblioteca
	char usuario[36];      //Nombre de usuario
	char matricu[11];      //Matrcula de usuario
	char calle[26],num[11],col[26],delomun[21],edo[16],CP[6],tel[12],fingre[11];
	int tipos[MP];         //Tipo de material:0=Libros,1=Revistas,etc.; -1=Ninguno
	char clasif[MP][31];
	int numejemp[MP];
	char numadqui[MP][7];
	char prestamo[MP];     //[][0]='I'nterna,'E'xterna o ' ' nada
	char fechpres[MP][11]; //Fecha prstamo
	char fechdevo[MP][11]; //Fecha devolucin
	int retardos;          //[3]; 0:leve,1:grave,2:extraordinario
	char fechactualiz[11]; //Fecha de actualizacin de retardos
 }usuar;

struct opcions
 {
	int impresora;    //Tipo de impresora:0=Matriz,1=Inyeccin,2=Lser
	char ruta[LR-12]; //Ruta de trabajo
	int dpad;         //Nm. de das que se presta a domicilio
	char dd[7];       //Devolucin:L,M,M,J,V,S y D;1=activo
	char logo;        //Muestra emblema o logotipo;1=activo
	char nombre[41];  //Nombre de la biblioteca,institucin,etc.
	char aar;         //Actualizacin de retardos: '1'=automtica al entrar,'0'=en la consulta
	char clave[AC];   //Contrasea de acceso
 }opconf;

union inspec
 {
	int c;
	char ch[2];
 }push,opc;
/*Arch. maestro,backup,ndice por adq. e ndices de ste*/
char BD[LR],BK[LR],BDADQ[LR],BKADQ[LR],ADQNDX[LR],IND[5][LR];
//BK[0]=BKADQ[0]='@':No se usarn backups por falta de espacio en disco.Se crearn si cambia de ruta o entra nuevamente al programa
/*Arch. temporales usados en Altas,Bajas y Cambios cuando se agrega(n) o quita(n) registros*/
char SCBTMP[3][LR];
/*Variables y punteros a arch.*/
long regs,regsxmat,regsxadq;//Nm. de registros por arch. maestro,ndice por materia y adquisicin
long pos; //Auxuliar en bsqueda,posicin del registro buscado y nm. de altas al salir de abcpadq()
long posinc; //Posicin donde inicia el primer ejemplar del ttulo en maestro por adq.
int mdfadq; //Cambios/altas en adq.=1,de lo contario=0
struct ffblk sizefile;	//Propiedades de archivo,solo se usa tamao de arch.
struct dfree *sizedisk; //Valores de informacin en disco
unsigned int size;      //Espacio en arreglo
char rutaexe[LR];       //Ruta de ejecucin del programa + OPCCFG
char diractual[LR-15];  //57 - 3 (A:\) - 12 (nombre.ext) = 42
char unidad[4];         //Para copiar unidad de trabajo para checar espacio en disco
int nx,carp,carpx;      //Nm. de ndices y contadores de carpeta base e indexada
int subcarp;            //Valores 0,1;0:visualiza carpetas de inicio
char csf0[AC],csf1[AC]; //Las dos partes de la clasif. del ejemplar
char titcarp[41];       //Para ttulo de carpeta donde se est
char txt[LTA][100];     //Texto ayuda de la carpeta nm. de lneas/tamao
char acceso[AC];        //Contine contrasea para acceder a carpetas bibliotecarias
int nl;                 //Nm. de lineas leidas en ayuda de la carpeta
char aux[AC];           //Para desplegar pruebas,leer y poner datos numricos
char fechoy[11];        //Contiene fecha actual
int ne;                 //Nm. ejemplar
char nq[7];             //Nm. adquisicin
FILE *fbd,*fad,*fdx,*ftmp,*ftmp2; //Punteros a arch.
/*SCB.CPP*/
void iniruta(); //Inicializa a nueva ruta y verifica existencia y/o crea arch. ndices
int leenomarch(char nom[],int lin); //Lee nombre de archivo
long calcregs(char ARCH[],int que); //Calcula nm. de registros en archivo maestro
int cmpregsmtryndx(char str[]); //Compara registros maestro con ndice
void cejassupynom(int clr,int clr2); //Pestaas y nombres sup. de carpeta principal
void cejasinfynom(int clr,int clr2); //Pestaas y nombres inf. de carpeta principal
/*FLOGHLP.CPP*/
void logoCB(void); //Logotipo del CB
void asignatex(int carp); //Pone texto de ayuda en arreglo txt
void ponayu(int lin,int clr); //Muestra u oculta ayuda
void jsoftc(void);
void disquette(int cx,int cy); //Dibuja disquette
/*FBIBSCB.CPP*/
void abcbib(int na); //Consulta y/o movimientos a catlogos
/*FUNDBIB.CPP*/
void nomypestsup(int clr,int clr2); //Visualiza pestaas y nombres superiores en carpeta catlogo
void muestralib(int ver,int nra,int a,int b,int c,struct campstructs vcs[]); //Visualiza parte del listado que hay en vcs[],segn ndice para catlogos
void opcmuestralib(int cia,int vtcal,int a,int b,int c,struct campstructs vcs[]); //Visualiza el ejemplar del listado segn ndice
void vertitlist(int a); //Visualiza encabezados del listado
int checafecha(char str[],int am); //Comprueba formato de fecha
void vercampsbib(int na); //Visualiza recuadros de cada uno de los datos para catlogos
void verdatosbib(struct campstructs ejemplar); //Visualiza los datos de la estructura reg
void recuadrclasif(struct campstructs reg); //Oculta datos del recuadro de clasificacin
struct campstructs leedatosbib(int *lec,int *t,struct campstructs *ejemplar,int am,int *y); //Lectura de los datos para la estructura reg
long recorrbib(FILE *fbd,char *FUENTE,long nr,long lugar); //Se usa en arch. maestro bibliogrfico sin marca
void impbib(void); //Controla impresin de inventario
void leefech(int x,char f[]); //lectura de fecha
void menserror(int err); //Mensajes de error en impresin de inventario
/*FUSUSCB.CPP*/
void abcusu(int na); //Consulta y movimientos a usuarios
/*FUNDUSU.CPP*/
void usunompestsup(int clr,int clr2); //Visualiza pestaas y nombres superiores en carpeta usuarios
void muestrausu(int ver,int nra,int a,int b,int c,struct usuario vcs[]); //Visualiza parte del listado que hay en vcs[],segn ndice para usuarios
void vercampsusu(void); //Visualiza recuadros de cada uno de los datos para usuarios
struct usuario leedatosusu(int *lec,struct usuario *usuar); //Lectura de los datos para la estructura usuar
int retraso(char fd[],char fh[]); //Checa si fd (fecha devolucin) es atrasada que fh (fecha hoy)
int abrenxcsf(int catal); //Retorna 0:existe y abre arch. ndice por clasif., -1:no existe
long recorrusu(FILE *fbd,char *FUENTE,long nr,long lugar); //Se usa en arch. maestro usuarios sin marca
/*FPREST.CPP*/
void fprest(int pos); //Prstamo y devolucin
void nompestprest(int clr,int clr2); //Visualiza nombres de pestaas en carpeta prstamo
void fechpresydevo(char fp[],char fd[],char IE); //Pone fecha de prstamo y devolucin,respectivamente en arreglos: dd/mm/aa
/*FADQUI.CPP*/
int abcpadqui(int abcp); //Agregar/Modificar/Consulta/Seleccin prstamo
void borrarecadq(void); //Borra listado del recuadro de eje,adq,env.
long buscadq(FILE *f,long nr,long dato,int bus); //Se usa para bsqueda en maestro por adquisicin ordenado por posicin en el maestro
void altbajadq(int va); //Guarda modif y altas de adq. y elimina las adq. cuando hay baja de un ttulo
void mostrar(int nrcia,struct adqdat vadq[]); //Acta con mostrar2() para visualizar listado de Eje,Adq. y Envio
void mostrar2(int v,struct adqdat vadq[]); //Seala en el listado nm. Eje,Adq. y Envio
void mensadqui(int abcp,int om); //Mensajes de funcin abcpadqui()
void desidebaja(int abcp); //Pregunta confirmacin de baja de nm. de ejemplar
long inseradq(FILE *f,long nr,long rins);  //Ordena arch. por adquisicin de acuerdo a la posicin en el catlogo maestro y nm. de ejemplar
long recorrposadq(FILE *f,char *FUENTE,long nr); //Elimina todos las adq. con el nm. de posicin en el catlogo
long recorradq(FILE *f,char *FUENTE,long nr,long lugar); //Elimina el registro de la posicin lugar
/*FIMPRIM.CPP*/
void mens(char *str);
void impusu(char te);
/*FUNDSCB.CPP*/
void recdrocsf(void); //Pone recuadro de clasificacin
void fopcio(void); //Opciones de prstamo y sistema
void nompestopc(int clr,int clr2); //Muestra/oculta pestaas y nombres de carpeta opciones
int ponopc(int numopc,int access); //Muestra/modifica contenido de subcarpetas de opciones
void recopcions(int clr,int opc,int i); //Muestra/oculta rectngulo punteado para pestaa Sistema o Programa
void borralins(void); //Borra contenido de carpeta
void inicia(char str[],int nc); //Inicializa strings con espacios
void recuadro(int x,int y,int nc,int nfte,int ad); //Dibuja cuadro en donde se leen datos
void menserrfech(int y,int valerr); //Mensaje de error en fecha incorrecta
void mensopc(int om); //Mensaje de carpeta OPCIONES
void mensabc(int ab,int om); //Mensaje de ayuda para consulta de carpeta
void mensajes(int y,char mens[],int color); //Muestra u oculta mensaje
void mensmoment(int y,char mens[],int t); //Mensajes de avisos
void mensmov(int nm,int om); //Mensaje al dar de alta o modificar
void flechasupdw(int a); //Visualiza flechas arriba y abajo
void abcarpinfynom(int clr,int clr2); //Pestaas y nombres inf. de abcbib() y abcusu()
void accion(int ceja,int clr); //Indica accin que se lleva a cabo al dar ENTER en cejas de consulta y movimientos
void vernreg_pag(int cont,long nregs,int pginc,int numpg); //Visualiza nm. de reg. y pg.
long recorrx(FILE *f,char *FUENTE,long nr,long lugar); //Se usa en arch. ndices sin marca
long insercion(FILE *f,long nr,long rins); //Ordena registro de arch. ndices
long buscax(FILE *f,long nr,char *dato,int bus); //Se usa para bsqueda en ndices
int  buscarr(struct index v[],int nr,char *dato,int bus); //Para posicionarse al escribir dato
long creaindex(long nr); //Vuelve a crear ndices de la carpeta actual,nr:nm. de reg. del DAT
void auxcreaindex(int acceso); //Auxiliar en la creacin de ndices
int  reindexa(FILE *f,long nr,long lugar); //Ordena registros indexados por el mtodo de bsqueda e insercin
int cmpfeches(char fes[],char fif[],int se); //es=0,fechas entrada e incial;devuelve 0:fes<fif,de lo contrario 1
																						 //es=1,fechas salida y final;devuelve 0:fes>fif,de lo contrario 1



/*JSoft Corporation. (C) Reservados todos los derechos 2002*/