/*Programa: IMPRIBIB.CPP
	 Proceso: Imprime inventario o ttulo seleccionado.Llamado en FBIBSCB.CPP*/

#include "io.h"
#include "time.h"
#include "bios.h"
#include "conio.h"
#include "dos.h"
#include "dir.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "ctype.h"

#include "fdatdisk.cpp"

#define MT     9      //Mx. de materias por libro
#define LR     57     //Logitud de ruta,incluyendo nombre del arch.
#define AC     16     //Nm. mx. de caracteres para contrasea
#define NTIXH  18     //Nm. de ttulos impresos por hoja
#define NEIXH  83     //Nm. de ejemplares impresos por hoja
#define NLIXH  83     //Nm. de lineas impresas por hoja

struct campstructs    //Campos estructuras
 {                    //Carpeta o tipo de material:0=LIBROS,1=REVISTAS,2=PERIODICOS,3=FOLLETOS,4=FASCICULOS,5=VARIOS,6=USUARIOS
	char titul[41];
	char autor[36];
	char campo3[21];    //Editorial o Fecha(dd/mm/aaaa)
	char temas[MT][41]; //Slo libro
	char consul;        //Area de consulta 'C' (slo consulta interna) o ' '
	char clasif[31];
	char volume[4];     //Volumen o Fascculo
	char edicio[20];
	char anio[5];       //Slo revista
	char num[4];        //Slo revista
	int existencia,prestados,numresrva;
	char prestamo;      //I:interno,E:externo
 }ejemplar;           //Utilizado en Prestamo para traer los datos del ttulo selecionado

struct adqdat
 {
	long posicion;    //Ubicacin en el catlogo
	int numejemp;     //Nm. consecutivo de los ejemplares del mismo ttulo
	char numadqui[7]; //Nm. consecutivo dado por el total del tipo de material en el catlogo
	char numenvio[9]; //Eje: 58/2000C = 58:consec/2000:ao,C o D:compra o donacin
	char fent[11],fsal[11]; //Fecha de entrada y salida
	char prestado;    //' '=No prestado,'P'=Prestado,'E'=extraviado
 }adqui;

struct parametros
 {
	int catal;              //Catlogo
	char imprime;           //"I"nventario o "T"tulo
	char fini[11],ffin[11]; //Fechas: anterior y actual inventario
	char ptl[41],cveptl[4]; //Nombre plantel y clave
	long nregs,nregsxadq;   //Nm. de registros del catlogo maestro y por adquisicin o
													//Posicin del ttulo en catlogo maestro y nm. de ejemplares
	int impresora;          //Tipo de impresora
	char rutacat[42],rutacatxadq[42],rutaindcsf[42]; //Ruta y nombres de archivos
 }param;

struct datinv
 {
	char clasif[31];
	int existot;
 }ultinv;

struct index
 {
	long posicion;    //Ubicacin en arch. maestro
	char atet[41];    //Para cualquiera de los campos indexados
 }ndx;

struct envio
 {
	long posicion; //Posicin respecto al catlogo maestro
	char env[9];   //Nm. de envo
 }nenvio;

struct ffblk sizefile; //Propiedades de archivo,solo se usa tamao de arch.
char inv_ant[13],inv_act[13],aux[16],fechoy[11];
int fin;
long posinc;
FILE *fr,*fw,*fbd,*fad,*fdx,*ftmp,*ftmp2;

void fmtofech(int dd,int mm,int aa,char f[]); //Pone en formato fecha
void enviaptr(int tps,char fi[],char ff[],char ptl[],char cve[],char imp,char *catbib,char *catadq,char *indcsf);
int cmpfeches(char fes[],char fif[],int se); //es=0,fechas entrada e incial;devuelve 0:fes<fif,de lo contrario 1
																						 //es=1,fechas salida y final;devuelve 0:fes>fif,de lo contrario 1
long buscadq(FILE *f,long nr,long dato,int bus); //Se usa para bsqueda en maestro por adquisicin ordenado por posicin en el maestro
long calcreginv(char ARCH[]);
long buscax(FILE *f,long nr,char *dato,int bus); //Se usa para bsqueda en ndices
void impencabezado(int np,int tps,char tit[],char fi[],char ff[],char ptl[],char cve[]); //Imprime encabezado
void impultimalin(void); //Imprime ltima linea
void mens(char *str);

/*Parmetros en argv:"I"nventario o "T"tulo,Nom. ptl,Cve. ptl,Nm. regs,Nm. regs x adq.,Tipo impresora,Ruta y catlogo y catlogo por adquisicin*/
int main(void)
 {
	struct tm *ptr; //Para uso de fecha y hora del sistema
	time_t lt;
	int numkey,edoprn=16,npags,cpag;
	long totent,totsal;
	unsigned long espace;
	struct dfree *sizedisk; //Valores de informacin en disco
	fin=0;
	if((ftmp=fopen("PARAMINV.SCB","rb"))==NULL) { printf("\n\aERROR: No se encontr archivo \"PARAMINV.SCB\"");return -1; } //Este archivo se genera en abcbib()
	else
	 {
		auto char s0[10],s1[10];
		lt=time(NULL);ptr=localtime(&lt);fmtofech(ptr->tm_mon,ptr->tm_mday,ptr->tm_year,fechoy); //Pone fecha actual
		fread(&param,sizeof(param),1,ftmp);fclose(ftmp);
		for(npags=cpag=0;param.fini[npags]!='\0';npags+=1) //Crea los
		 if(param.fini[npags]!='/') { inv_ant[cpag]=param.fini[npags];inv_act[cpag++]=param.ffin[npags]; } //nombres de los
		inv_ant[cpag]=inv_act[cpag++]='\0';strcat(inv_ant,".INV");strcat(inv_act,".INV"); //archivos de inventario anterior y actual
		if(param.impresora==1)
		 {
			biosprint(1,numkey,0);
			edoprn=biosprint(2,numkey,0);
		 }
		else { edoprn=16;biosprint(1,numkey,0); } //edoprn=biosprint(1,numkey,0);
		if(edoprn==16)
		 if(param.imprime=='I')
			{
			 ftmp=fopen("ENTRADAS.TMP","wb");ftmp2=fopen("SALIDAS.TMP","wb");
			 strncpy(aux,param.rutacat,3);aux[3]='\0'; //Para calcular espacio en disco
			 if((fbd=fopen(param.rutacat,"rb"))!=NULL)
				for(npags=0;npags<param.nregs && fin==0;npags+=1)
				 {
					fread(&ejemplar,sizeof(ejemplar),1,fbd); //Lee ejemplar del catlogo maestro
					if((fad=fopen(param.rutacatxadq,"rb"))!=NULL)
					 if(buscadq(fad,param.nregsxadq,npags,0)>=0) //Busca el nm de posicin del ttulo en maestro por adq.
						{
						 posinc=buscadq(fad,param.nregsxadq,npags,1); //Busca el primer de los ejemplares con el nm de posicin
						 fseek(fad,posinc*sizeof(adqui),0);nenvio.posicion=npags;
						 for(totent=totsal=edoprn=0;edoprn<ejemplar.existencia && fin==0;edoprn+=1)
							{
							 if(kbhit()) { fin=-6;break; } //Presion tecla para cancelar impresin
							 fread(&adqui,sizeof(adqui),1,fad);strcpy(nenvio.env,adqui.numenvio);
							 espace=espacioendisco(sizedisk,aux);
							 if(espace>=2*sizeof(nenvio))
								{
								 if(cmpfeches(adqui.fent,param.fini,0)==1 && cmpfeches(adqui.fent,param.ffin,1)==1)
									{ fwrite(&nenvio,sizeof(nenvio),1,ftmp);totent+=1; } //Entradas y salidas del ejemplar dentro del intervalo fi y ff
								 if(cmpfeches(adqui.fsal,param.ffin,1)==1 && cmpfeches(adqui.fsal,param.fini,0)==1)
									{ fwrite(&nenvio,sizeof(nenvio),1,ftmp2);totsal+=1; } //las guarda en temporales para luego imprimir
								}
							 else	fin=-2; //ESPACIO INSUFICIENTE EN DISCO PARA TERMINAR DE CREAR ARCHIVOS TEMPORALES
							}fclose(fad);
						}
					 else fin=-5; //ERROR: CATALOGO DE ADQUISICIONES NO CORRESPONDE AL CATALOGO MAESTRO
					else fin=-4; //ERROR: CATALOGO DE ADQUISICIONES NO EXISTE
				 }
			 else fin=-3; //ERROR: CATALOGO MAESTRO NO EXISTE
			 fcloseall();
			 if(!kbhit() && fin==0)
				{
				 npags=param.nregs+(totent+totsal)/4; //Nm. de ttulos + los que se forman con las ent. y sal.
				 npags=npags/NTIXH;
				 if((param.nregs+(totent+totsal)/4)%NTIXH==0) npags-=1;
				 enviaptr(npags,param.fini,param.ffin,param.ptl,param.cveptl,param.imprime,param.rutacat,param.rutacatxadq,param.rutaindcsf);
				}
			 else edoprn=fin;
			 if(access("ENTRADAS.TMP",0)==0) remove("ENTRADAS.TMP");
			 if(access("SALIDAS.TMP",0)==0) remove("SALIDAS.TMP");
			}
		 else
			if(!kbhit())
			 {
				npags=param.nregs/NEIXH;
				if(param.nregs%NEIXH==0) npags-=1;
				enviaptr(npags,param.fini,param.ffin,param.ptl,param.cveptl,param.imprime,param.rutacat,param.rutacatxadq,param.rutaindcsf);
			 }
			else edoprn=-6;
		else return(edoprn);
	 }
	return(edoprn);
 }

void fmtofech(int mm,int dd,int aa,char f[])
 {
	char aux[5];
	mm+=1;itoa(mm,aux,10);
	if(mm<10) { f[0]='0';f[1]=aux[0]; }
	else strcpy(f,aux);
	f[2]='/';f[3]='\0';itoa(dd,aux,10);
	if(dd<10) { f[3]='0';f[4]=aux[0]; }
	else strcat(f,aux);
	f[5]='/';f[6]='\0';
	itoa(aa+1900,aux,10);strcat(f,aux);
 }

void enviaptr(int tps,char fi[],char ff[],char ptl[],char cve[],char imp,char *catbib,char *catadq,char *indcsf) //np:nm de pg,tps:tot de pgs,fech:fecha actual
 {
	char csf0[AC],csf1[AC],tit[50];
	int np,A,B,E,W,K,ca;
	long T0=0,T1=0,T2=0,T3=0,T4=0,T5=0,lpp,cr=0; //lpp:lineas por pg.,cr:contador de registros
	long pent=0,psal=0; //posicin en temporal de entradas y salidas
	if((fbd=fopen(catbib,"rb"))==NULL) return;
	if(imp=='I')
	 {
		if(access(inv_ant,0)==0) fr=fopen(inv_ant,"rb");
		fw=fopen(inv_act,"wb");
		strcpy(tit,"INVENTARIO DE ");
		switch(param.catal) //Ttulo fichero
		 {
			case 0:strcat(tit,"LIBROS");break;
			case 1:strcat(tit,"REVISTAS");break;
			case 2:strcat(tit,"PERIODICOS");break;
			case 3:strcat(tit,"FOLLETOS");break;
			case 4:strcat(tit,"FASCICULOS");break;
			case 5:strcat(tit,"VARIOS");
		 }
		strcat(tit," DE LA BIBLIOTECA");
	 }
	else
	 {
		fseek(fbd,param.nregs*sizeof(ejemplar),0);
		strcpy(tit,"INFORMACION DEL TITULO EXISTENTE EN LA BIBLIOTECA");
	 }
	for(np=0;np<=tps && fin==0;np+=1)
	 {
		impencabezado(np,tps,tit,fi,ff,ptl,cve);
		if(kbhit()) { fin=-6;break; }
		if(imp=='I')
		 for(lpp=0;lpp<NLIXH && cr<param.nregs;cr+=1)
			{
			 fread(&ejemplar,sizeof(ejemplar),1,fbd);
			 mens("            ");(ejemplar.consul!='C' && ejemplar.consul!='F') ? bdos(0x5,' ',0) : bdos(0x5,ejemplar.consul,0);mens("              A");mens(ejemplar.autor);for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.autor);ca>0;ca-=1) bdos(0x5,' ',0);mens("                                    ");
			 mens("                                                                                            ");
			 bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
			 for(ca=0;ejemplar.clasif[ca]!='\0';ca+=1) (ca<15) ? csf0[ca]=ejemplar.clasif[ca] : csf1[ca-15]=ejemplar.clasif[ca];
			 csf0[15]=csf1[ca-15]='\0';
			 mens("            ");mens(csf0);for(ca=sizeof(csf0)-1-strlen(csf0);ca>0;ca-=1) bdos(0x5,' ',0);mens("T");mens(ejemplar.titul);
			 for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.titul);ca>0;ca-=1) bdos(0x5,' ',0);
			 if((fad=fopen(catadq,"rb"))!=NULL)
				if(buscadq(fad,param.nregsxadq,cr,0)>=0) //Busca el nm de posicin del ttulo en maestro por adq.
				 {
					posinc=buscadq(fad,param.nregsxadq,cr,1); //Busca el primer de los ejemplares con el nm de posicin
					fseek(fad,posinc*sizeof(adqui),0);
					for(A=B=E=W=K=0;A+B+E<ejemplar.existencia;)
					 {
						if(kbhit()) { fin=-6;break; }
						fread(&adqui,sizeof(adqui),1,fad);
						if(adqui.numenvio[strlen(adqui.numenvio)-1]=='C')
						 if(adqui.prestado!='E') A+=1;else E+=1;
						else if(adqui.prestado!='E') B+=1;else E+=1;
						if(cmpfeches(adqui.fent,fi,0)==1 && cmpfeches(adqui.fent,ff,1)==1) W+=1;
						if(cmpfeches(adqui.fsal,ff,1)==1 && cmpfeches(adqui.fsal,fi,0)==1) K+=1;
					 }
				 }
				else fin=-5;
			 else fin=-4;
			 fclose(fad);
			 if(fin!=0) break;
			 T0+=A;T1+=B;T2+=(A+B+E);
			 mens("PIEZA ");
			 itoa(A,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //A
			 itoa(B,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //B
			 itoa(A+B,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //A+B=X
			 itoa(A+B+E,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //Z
			 itoa(-E,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //X-Z
			 ultinv.existot=0;
			 if(access(inv_ant,0)==0)
				{
				 fread(&ultinv,sizeof(ultinv),1,fr); //Lee del anterior inventario
				 fdx=fopen(indcsf,"rb");
				 if((posinc=buscax(fdx,param.nregs,ultinv.clasif,0))>=0)
					{
					 fseek(fdx,posinc*sizeof(ndx),0);fread(&ndx,sizeof(ndx),1,fdx);
					 if(strcmp(ultinv.clasif,ndx.atet)!=0) ultinv.existot=0; //NO CORRESPONDE CATALOGO AL INDICE
					}fclose(fdx);
				}
			 T3+=ultinv.existot;itoa(ultinv.existot,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //V
			 T4+=W;T5+=K;
			 itoa(W,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //W
			 itoa(K,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //K
			 itoa(ultinv.existot+W-K,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //V+W-K=Y
			 itoa(A+B-(ultinv.existot+W-K),aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //X-Y
			 mens("              ");
			 ultinv.existot=A+B;fwrite(&ultinv,sizeof(ultinv),1,fw); //Guarda para el ltimo (actual) inventario
			 bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
			 mens("            ");mens(csf1);for(ca=sizeof(csf1)-1-strlen(csf1);ca>0;ca-=1) bdos(0x5,' ',0);mens("E");mens(ejemplar.campo3);
			 for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.campo3);ca>0;ca-=1) bdos(0x5,' ',0);mens("                                    ");
			 mens("                                                                                            ");
			 bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
			 for(strcpy(aux,ejemplar.volume),ca=4-strlen(aux);ca>0;ca-=1) strcat(aux," ");strcat(aux,ejemplar.num);strcat(aux," ");strcat(aux,ejemplar.anio);
			 mens("            ");mens(aux);for(ca=sizeof(csf0)-1-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens("                                                                             ");
			 mens("                                                                                            ");
			 bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
			 if(W>0)
				{
				 for(ftmp=fopen("ENTRADAS.TMP","rb"),fseek(ftmp,pent*sizeof(nenvio),0);W>0;W-=1)
					{
					 mens("                                                                                                        ");
					 mens("                                                                              ");
					 fread(&nenvio,sizeof(nenvio),1,ftmp);pent+=1;
					 for(ca=13-strlen(nenvio.env);ca>0;ca-=1) bdos(0x5,' ',0);mens(nenvio.env);mens(" ");
					 if(lpp<NLIXH) { bdos(0x5,'\n',0);bdos(0x5,'\r',0); }
					 else { lpp=0;impultimalin();impencabezado(np,tps,tit,fi,ff,ptl,cve); }
					}fclose(ftmp);
				}
			 if(K>0)
				{
				 for(ftmp2=fopen("SALIDAS.TMP","rb"),fseek(ftmp2,psal*sizeof(nenvio),0);K>0;K-=1)
					{
					 mens("                                                                                                        ");
					 mens("                                                                              ");
					 fread(&nenvio,sizeof(nenvio),1,ftmp2);psal+=1;
					 for(ca=13-strlen(nenvio.env);ca>0;ca-=1) bdos(0x5,' ',0);mens(nenvio.env);mens(" ");
					 if(lpp<NLIXH) { bdos(0x5,'\n',0);bdos(0x5,'\r',0); }
					 else { lpp=0;impultimalin();impencabezado(np,tps,tit,fi,ff,ptl,cve); }
					}fclose(ftmp2);
				}
			 if(kbhit()) { fin=-6;break; }
			 if(lpp<NLIXH-1 && cr<param.nregs-1) //{ impultimalin();lpp+=1; }
				{
				 mens("            ");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
				 bdos(0x5,'',0);mens("");
				 for(ca=0;ca<6;ca+=1) { bdos(0x5,'',0);mens(""); }
				 for(ca=0;ca<4;ca+=1) { bdos(0x5,'',0);mens(""); }bdos(0x5,'',0);mens("");bdos(0x5,'',0);
				 bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
				}
			}
		else //imprime datos del ttulo
		 {
			if(cr==0)	fread(&ejemplar,sizeof(ejemplar),1,fbd); //slo una vez en la primer hoja
			fad=fopen(catadq,"rb");
			for(lpp=0;lpp<NEIXH && (cr<ejemplar.existencia || cr<MT);cr+=1)
			 {
				mens("            ");
				if(cr==0) //slo una vez en la primer hoja (CLASIF/DESCRIPCION/UNIDAD/TOTAL SEGUN INVENTARIO FISICO)
				 {
					(ejemplar.consul!='C' && ejemplar.consul!='F') ? bdos(0x5,' ',0) : bdos(0x5,ejemplar.consul,0);
					mens("              A");mens(ejemplar.autor);for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.autor);ca>0;ca-=1) bdos(0x5,' ',0);
					mens("PIEZA ");
					if((ftmp=fopen(catadq,"rb"))!=NULL)
					 if(buscadq(ftmp,param.nregsxadq,param.nregs,0)>=0) //Busca el nm de posicin del ttulo en maestro por adq.
						{
						 posinc=buscadq(ftmp,param.nregsxadq,param.nregs,1); //Busca el primer de los ejemplares con el nm de posicin
						 fseek(ftmp,posinc*sizeof(adqui),0);
						 for(A=B=E=0;A+B+E<ejemplar.existencia;)
							{
							 if(kbhit()) { fin=-6;break; }
							 fread(&adqui,sizeof(adqui),1,ftmp);
							 if(adqui.numenvio[strlen(adqui.numenvio)-1]=='C')
								if(adqui.prestado!='E') A+=1;else E+=1;
							 else if(adqui.prestado!='E') B+=1;else E+=1;
							}
						}
					 else fin=-5;
					else fin=-4;
					fclose(ftmp);
					if(fin!=0) break;
					itoa(A,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //COMPRA
					itoa(B,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //DONACION
					itoa(A+B,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens(" "); //TOTAL
				 }
				if(cr==1) //slo una vez en la primer hoja (CLASIF/DESCRIPCION/UNIDAD/TOTAL SEGUN INVENTARIO FISICO)
				 {
					for(ca=0;ejemplar.clasif[ca]!='\0';ca+=1) (ca<15) ? csf0[ca]=ejemplar.clasif[ca] : csf1[ca-15]=ejemplar.clasif[ca];
					csf0[15]=csf1[ca-15]='\0';
					mens(csf0);for(ca=sizeof(csf0)-1-strlen(csf0);ca>0;ca-=1) bdos(0x5,' ',0);mens("T");
					mens(ejemplar.titul);for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.titul);ca>0;ca-=1) bdos(0x5,' ',0);
					mens("                                    ");
				 }
				if(cr==2) //slo una vez en la primer hoja (CLASIF/DESCRIPCION/UNIDAD/TOTAL SEGUN INVENTARIO FISICO)
				 {
					mens(csf1);for(ca=sizeof(csf1)-1-strlen(csf1);ca>0;ca-=1) bdos(0x5,' ',0);mens("E");
					mens(ejemplar.campo3);for(ca=sizeof(ejemplar.titul)-1-strlen(ejemplar.campo3);ca>0;ca-=1) bdos(0x5,' ',0);
					mens("                                    ");
				 }
				if(cr==3)
				 {
					for(strcpy(aux,ejemplar.volume),ca=4-strlen(aux);ca>0;ca-=1) strcat(aux," ");strcat(aux,ejemplar.num);strcat(aux," ");strcat(aux,ejemplar.anio);
					mens(aux);for(ca=sizeof(csf0)-1-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);
					mens("                                                                             ");
				 }
				if(cr>3) mens("                                                                                            ");
				if(cr<MT) for(mens(ejemplar.temas[cr]),ca=sizeof(ejemplar.temas[cr])-1-strlen(ejemplar.temas[cr]);ca>0;ca-=1) bdos(0x5,' ',0);mens(" "); //MATERIAS
				if(cr<ejemplar.existencia)
				 {
					itoa(cr+1,aux,10);for(ca=3-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //EJE
					fseek(fad,(posinc+cr)*sizeof(adqui),0);fread(&adqui,sizeof(adqui),1,fad);
					mens(adqui.numadqui);for(ca=8-strlen(adqui.numadqui);ca>0;ca-=1) bdos(0x5,' ',0);mens(" "); //NUM ADQ
					mens(adqui.numenvio);for(ca=10-strlen(adqui.numenvio);ca>0;ca-=1) bdos(0x5,' ',0);mens(" "); //NUM ENVIO
					mens(adqui.fent);for(ca=11-strlen(adqui.fent);ca>0;ca-=1) bdos(0x5,' ',0);mens(" "); //ENTRADA
					mens(adqui.fsal);for(ca=12-strlen(adqui.fsal);ca>0;ca-=1) bdos(0x5,' ',0);bdos(0x5,adqui.prestado,0);mens(""); //SALIDA
				 }
				else mens("                                                  ");
				if(kbhit()) { fin=-6;break; } //Presion tecla para cancelar impresin
				bdos(0x5,'\n',0);bdos(0x5,'\r',0);lpp+=1;
				if(lpp==NLIXH) impultimalin();
			 }fclose(fad);
			if(kbhit()) { fin=-6;break; }
		 }
		impultimalin();
		if(param.imprime=='I')
		 {
			for(ca=0;ca<79;ca+=1) bdos(0x5,' ',0); //Sangra izq. de totales
			itoa(T0,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total compra
			itoa(T1,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total donacin
			itoa(T0+T1,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total fsico
			itoa(T2,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total topograf.
			itoa(T2-(T0+T1),aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total diferencia
			itoa(T3,aux,10);for(ca=9-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total INV.FIS. al
			itoa(T4,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total entradas
			itoa(T5,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total salidas
			itoa(T3+T4-T5,aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total total al
			itoa(T0+T1-(T3+T4-T5),aux,10);for(ca=11-strlen(aux);ca>0;ca-=1) bdos(0x5,' ',0);mens(aux);mens("  "); //Total dif. inv. fis. y total al
		 }
		if(fin!=0) { bdos(0x5,'\n',0);bdos(0x5,'\r',0);mens("*** IMPRESION CANCELADA ***"); }
		bdos(0x5,'\f',0);
	 }
	fclose(fbd);fclose(fr);fclose(fw);if(fin!=0) remove(inv_act);
 }

int cmpfeches(char fes[],char fif[],int se)
 {
	char fes0[3],fes1[3],fes2[5],fif0[3],fif1[3],fif2[5];
	int g=0;
	for(;fes[g]!='\0';g+=1)
	 switch(g)
		{
		 case  0:
		 case  1:fes0[g]=fes[g];fif0[g]=fif[g];break;
		 case  2:fes0[g]=fif0[g]='\0';break;
		 case  3:
		 case  4:fes1[g-3]=fes[g];fif1[g-3]=fif[g];break;
		 case  5:fes1[g-3]=fif1[g-3]='\0';break;
		 case  6:
		 case  7:
		 case  8:
		 case  9:fes2[g-6]=fes[g];fif2[g-6]=fif[g];
		}fes2[g-6]=fif2[g-6]='\0';
	if(se==0)
	 if(strcmp(fes2,fif2)>0) return 1;
	 else if(strcmp(fes2,fif2)==0)
				 if(strcmp(fes0,fif0)>0) return 1;
				 else if(strcmp(fes0,fif0)==0)
							 return (strcmp(fes1,fif1)>=0) ? 1 : 0;
							else return 0;
				else return 0;
	else
	 if(strcmp(fes2,fif2)<0) return 1;
	 else if(strcmp(fes2,fif2)==0)
				 if(strcmp(fes0,fif0)<0) return 1;
				 else if(strcmp(fes0,fif0)==0)
							 return (strcmp(fes1,fif1)<0) ? 1 : 0;
							else return 0;
				else return 0;
 }

long buscadq(FILE *f,long nr,long dato,int bus)
 {
	long ini=0,fin=nr,med=fin/2;
	struct adqdat x;
	if(nr<=0) return -3;
	while(1)
	 {
		fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		if(dato<x.posicion) { fin=med;med=(med-ini)/2+ini;if(fin==med) break; }
		else if(dato>x.posicion) { ini=med;med=(fin-med)/2+med;if(ini==med) break;	}
				 else break;
	 }
	if(dato==x.posicion) //Encontrado
	 while(1) //Buscar el primero
		{
		 if(med>0) med-=1;else return med;
		 fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		 if(dato!=x.posicion) { med+=1;return med; }
		}
	else if(bus==0) return -2;
			 else if(dato>x.posicion) return med+1;
						else return med-1;
 }

long calcreginv(char ARCH[])
 {
	if(findfirst(ARCH,&sizefile,0)==-1) return 0;
	return sizefile.ff_fsize/sizeof(ultinv); //Calcula registros del ltimo inventario
 }

long buscax(FILE *f,
						long nr,
						char *dato, //Dato a buscar
						int bus)    //Bsqueda: 0=normal,1=para ubicar
 {
	long ini=0,fin=nr,med=fin/2;
	struct index x;
	if(nr<=0) return -3;
	while(1)
	 {
		fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		if(strcmp(dato,x.atet)<0) { fin=med;med=(med-ini)/2+ini;if(fin==med) break; }
		else if(strcmp(dato,x.atet)>0) { ini=med;med=(fin-med)/2+med;if(ini==med) break;	}
				 else break;
	 }
	if(strcmp(dato,x.atet)==0) //Encontrado
	 while(1) //Buscar el primero
		{
		 if(med>0) med-=1;else return med;
		 fseek(f,med*sizeof(x),0);fread(&x,sizeof(x),1,f);
		 if(strcmp(dato,x.atet)!=0) { med+=1;return med; }
		}
	else if(bus==0) return -2;
			 else if(strcmp(dato,x.atet)>0) return med+1;
						else return med-1;
 }

void impencabezado(int np,int tps,char tit[],char fi[],char ff[],char ptl[],char cve[])
 {
	int ancho=213,ca,a=strlen(tit);
	a=ancho/2-a/2; //ancho:ancho de pg. en caract.
	for(bdos(0x5,'\r',0),ca=0;ca<a;ca+=1) bdos(0x5,' ',0);
	for(mens(tit),ca=ancho-a;ca<ancho-strlen("HOJA: ")-13;ca+=1) bdos(0x5,' ',0);mens("HOJA: ");mens(itoa(np+1,aux,10));
	for(bdos(0x5,'\n',0),bdos(0x5,'\r',0),ca=0;ca<ancho-strlen("  DE: ")-13;ca+=1) bdos(0x5,' ',0);mens("  DE: ");mens(itoa(tps+1,aux,10));
	a=strlen("AREA RESPONSABLE       CLAVE");a=ancho/2-a/2;
	for(bdos(0x5,'\n',0),bdos(0x5,'\r',0),ca=0;ca<a;ca+=1) bdos(0x5,' ',0);mens("AREA RESPONSABLE       CLAVE");
	for(ca=ancho-a;ca<ancho-strlen("MES   DIA   AO")-14;ca+=1) bdos(0x5,' ',0);mens("MES   DIA   AO");
	for(bdos(0x5,'\n',0),bdos(0x5,'\r',0),ca=0;ca<a;ca+=1) bdos(0x5,' ',0);
	strncpy(aux,ptl,10);aux[10]='\0';mens(aux);mens("             ");mens(cve);
	for(ca=0;ca<65;ca+=1) bdos(0x5,' ',0);strncpy(aux,fechoy,2);aux[2]='\0';mens(aux);mens("    ");
	for(ca=3;ca<5;ca+=1) aux[ca-3]=fechoy[ca];aux[2]='\0';mens(aux);mens("    ");
	for(ca=6;ca<10;ca+=1) aux[ca-6]=fechoy[ca];aux[4]='\0';mens(aux);
	for(bdos(0x5,'\n',0),bdos(0x5,'\r',0),ca=0;ca<a;ca+=1) bdos(0x5,' ',0);
	for(ca=12;ca<strlen(ptl)-1;ca+=1) ejemplar.titul[ca-12]=ptl[ca];ejemplar.titul[ca-12]='\0';
	mens(ejemplar.titul);
	bdos(0x5,'\n',0);bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("            ");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
	bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
	if(param.imprime=='I')
	 {
		for(ca=0;ca<3;ca+=1) { bdos(0x5,'',0);mens(""); }
		for(ca=0;ca<4;ca+=1) { bdos(0x5,'',0);mens(""); }bdos(0x5,'',0);mens("");
	 }
	else mens("");
	bdos(0x5,'',0);
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("                                                                                                          ");
	if(param.imprime=='I')
	 mens("                                ENTRADAS    SALIDAS                DIF. ENTRE               ");
	else mens("                                                                                           ");
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("                                          DESCRIPCION                      TOTAL SEGUN INVENTARIO FISICO  ");
	if(param.imprime=='I')
	 mens(" TOTAL S/ DIFERENCIA INV.FIS.     del         del         TOTAL    INV.FISICO   REFERENCIA  ");
	else mens("                                                                                           ");
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("             CLASIFICACION       A=AUTOR  T=TITULO  E=EDITORIAL     UNIDAD                              ");
	if(param.imprime=='I')
	 { mens(" CATALOGO               al     ");mens(fi);mens("  ");mens(fi);mens("      al       Y  TOTAL     ENTRADAS   "); }
	else mens("         M  A  T  E  R  I  A  S          EJE  NUM ADQ  NUM ENVIO   ENTRADA      SALIDA    =");
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("                                                                            COMPRA   DONACION   TOTAL   ");
	if(param.imprime=='I')
	 { mens(" TOPOGRAF   (+  -)  ");mens(fi);mens("     al          al      ");mens(ff);mens("      al       Y  SALIDAS  "); }
	else mens("                                                                                           ");
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("                                                                                                        ");
	if(param.imprime=='I')
	 { mens("                               ");mens(ff);mens("  ");mens(ff);mens("              ");mens(ff);mens("               "); }
	else mens("                                                                                           ");
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("            ");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
	bdos(0x5,'',0);mens("");
	for(ca=0;ca<3;ca+=1) { bdos(0x5,'',0);mens(""); }
	if(param.imprime=='I')
	 {
		for(ca=0;ca<3;ca+=1) { bdos(0x5,'',0);mens(""); }
		for(ca=0;ca<4;ca+=1) { bdos(0x5,'',0);mens(""); }bdos(0x5,'',0);mens("");
	 }
	else mens("");
	bdos(0x5,'',0);
	bdos(0x5,'\n',0);bdos(0x5,'\n',0);bdos(0x5,'\r',0);
	mens("            ");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
	bdos(0x5,'',0);mens("");//bdos(0x5,'',0);mens("");
	for(ca=0;ca<3;ca+=1) { bdos(0x5,'',0);mens(""); }
	if(param.imprime=='I')
	 {
		for(ca=0;ca<3;ca+=1) { bdos(0x5,'',0);mens(""); }
		for(ca=0;ca<4;ca+=1) { bdos(0x5,'',0);mens(""); }bdos(0x5,'',0);mens("");
	 }
	else mens("");
	bdos(0x5,'',0);
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
 }

void impultimalin(void)
 {
	int c;
	mens("            ");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");bdos(0x5,'',0);mens("");
	bdos(0x5,'',0);mens("");
	for(c=0;c<3;c+=1) { bdos(0x5,'',0);mens(""); }
	if(param.imprime=='I')
	 {
		for(c=0;c<3;c+=1) { bdos(0x5,'',0);mens(""); }
		for(c=0;c<4;c+=1) { bdos(0x5,'',0);mens(""); }bdos(0x5,'',0);mens("");
	 }
	else mens("");
	bdos(0x5,'',0);
	bdos(0x5,'\n',0);bdos(0x5,'\r',0);
 }

void mens(char *str) { while(*str) bdos(0x5,*str++,0); }



/*JSoft Corporation. (C) Reservados todos los derechos 2002*/